<template>
  <div class="post-container" :class="{'post-end-line': post.endLine, 'post-container-small': post.small, 'lower-bottom-padding': isLastLayerText()}">
        <a class="anchor-point" :id="post.id"></a>


      <div class="post-thread">
          <img class="post-avatar" :class="{'post-avatar-small': post.small}" :src="post.header.avatar" :alt="post.header.text">
          <div v-if="post.thread" class="thread-line"></div>
      </div>
      <div class="post-content" :class="{'post-content-small': post.small}">
        <div v-if="!post.small && post.header.text" class="post-header">
            <div class="header-text" :style="post.header.style">{{post.header.text}} <span class="header-username-date">{{post.header.usernameAndDate}}</span></div>
        </div>
        <div v-for="layer of post.layers" class="post-layer">

            <!-- Text Layer -->
            <div v-if="layer.type == 'text'" class="post-layer-text">
                <p v-for="line of layer.text" :style="layer.style" :class="{'line-without-margin': isLastElement(layer.text, line)}">{{line}}</p>
            </div>

            <!-- Image Layer -->
            <div v-if="layer.type == 'image'" class="post-layer-image">
                <div  v-if="layer.isYoutube" class="image-card" @click="videoImageClicked()">
                    <img v-if="!showVideo" ref="videoContainer" :src="layer.image" alt="Thorchain" :class="{'without-link': !layer.link}" :style="layer.style">
                    <PostYoutube v-else :videoId="layer.videoId" :width="videoWidth" :height="videoHeight" />
                    <div class="image-card-link" v-if="layer.link" :style="layer.linkStyle">
                        <div class="image-link-header">
                            {{layer.linkHeader}}
                        </div>
                        <div class="image-link-caption" :style="layer.linkCaptionStyle">
                            {{layer.linkCaption}}
                        </div>
                    </div>

                </div>
                <ExtLink v-else :linkProps="layer.link" class="image-card">
                    <img :src="layer.image" alt="Thorchain" :class="{'without-link': !layer.link}" :style="layer.style">
                    <div class="image-card-link" v-if="layer.link" :style="layer.linkStyle">
                        <div class="image-link-header">
                            {{layer.linkHeader}}
                        </div>
                        <div class="image-link-caption" :style="layer.linkCaptionStyle">
                            {{layer.linkCaption}}
                        </div>
                    </div>
                </ExtLink>
                <!-- <div class="image-card" :style="{'background-image': 'url(\''+layer.image+'\')', 'color': 'red'}"></div> -->
            </div>

            <!-- Text Card Layer  -->
            <div v-if="layer.type == 'text-card'" class="post-layer-text-card">
                <ExtLink :linkProps="layer.link" class="card-container" >
                    <div class="post-text-card" :style="layer.style">
                        <div>
                            <span v-for="part of layer.content" :style="part.style">{{part.text}}<span v-if="part.tag" :style="part.tagStyle" class="tag">{{part.tag}}</span><br v-if="part.nextLine"></span>
                        </div>
                    </div>
                    <div class="image-card-link" v-if="layer.link" :style="layer.linkStyle">
                        <div class="image-link-header">
                            {{layer.linkHeader}}
                        </div>
                        <div class="image-link-caption" :style="layer.linkCaptionStyle">
                            {{layer.linkCaption}}
                        </div>
                    </div>
                </ExtLink>
            </div>

            <!-- Table Layer -->
            <div v-if="layer.type == 'table'" class="post-layer-table" :style="layer.table.style">
                <div v-for="row of layer.table.rows">
                    <ExtLink :linkProps="row.link" class="table-row" :class="{'table-row-green': row.link, 'table-row-disable': row.disable}" :style="row.style">
                        <div class="table-col" v-for="col of row.cols" :style="col.style">
                            <div v-if="typeof col === 'object'" :style="col.textStyle">
                                <span v-if="Array.isArray(col.content)">
                                    <span v-for="part of col.content">
                                    {{part}}<br>
                                    </span>
                                </span>
                                <span v-else>{{col.content}}</span>
                            </div>
                            <div v-else>{{col}}</div>
                        </div>
                    </ExtLink>
                </div>
            </div>

            <!-- Custom Layer -->
            <div v-if="layer.type == 'custom-component'" :class="layer.component.classes">
                <component :is="layer.component.name" v-if="layer.component.data" :data="layer.component.data"></component>
            </div>


            <!-- Text Link Layer -->
            <div v-if="layer.type == 'text-link'" class="post-layer-text-link">
                <ExtLink :linkProps="layer.link" class="post-text-link" :style="layer.style">{{layer.text}}</ExtLink>
            </div>

            <!-- Table Links -->
            <div v-if="layer.type == 'table-links'" class="post-layer-table post-layer-table-links">
                <div v-for="row of layer.links">
                    <ExtLink :linkProps="row.link" class="table-row" :class="{'table-row-green': row.link, 'table-row-disable': row.disable}">
                        <div class="table-col" v-if="typeof row.text === 'object'" :style="row.text.style">{{row.text.content}}
                            <span class="row-tag" v-if="row.tag">{{row.tag}}</span></div>
                        <div class="table-col" v-else><span>{{row.text}}<span class="row-tag" v-if="row.tag">{{row.tag}}</span></span></div>
                    </ExtLink>
                </div>
            </div>

            <!-- Code snippet -->
            <div v-if="layer.type == 'code-snippet'" class="post-layer-image post-layer-code-snippet">
                <ExtLink :linkProps="layer.link" class="image-card" :style="layer.style">
                    <img :src="layer.image" alt="Thorchain" >
                    <div class="image-card-link" v-if="layer.link" :style="layer.linkStyle">
                        <div class="image-link-header">
                            {{layer.linkHeader}}
                        </div>
                        <div class="image-link-caption">
                            {{layer.linkCaption}}
                        </div>
                    </div>
                </ExtLink>
                <!-- <div class="image-card" :style="{'background-image': 'url(\''+layer.image+'\')', 'color': 'red'}"></div> -->
            </div>
        </div>

      </div>
  </div>
</template>

<script>
import ExtLink from "../../../components/main/ExtLink.vue"
import  PostYoutube from "./PostYoutube"
export default {
    components: {
        ExtLink,
        PostYoutube
    },
    props: {
        post: Object
    },
    data(){
        return {
            videoWidth: 300,
            showVideo: false
        }
    },
    methods: {
        isLastElement(array, element){
            return array.indexOf(element) == array.length - 1
        },
        isLastLayerText(){
            if(!this.post.layers) return false
            return this.post.layers[this.post.layers.length-1].type == 'text-link' ||
            this.post.layers[this.post.layers.length-1].type == 'text'
        },
        getVideoWidth(){
            console.log("get video width")
            var parent = this.$refs['videoContainer']
            console.log(parent)
        },
        videoImageClicked(){
            var parent = this.$refs['videoContainer']
            if(!parent[0]) return
            var parentWidth = parent[0].clientWidth
            var parentHeight = parent[0].clientHeight
            this.videoWidth = parentWidth
            this.videoHeight = parentHeight
            this.showVideo = true
        }
    },
    mounted(){
    }

}
</script>

<style lang="scss">
.post-container{
    color: white;
    padding: 0.9375rem 1.25rem 0.3125rem 1.25rem;
    margin-top: 1.25rem ;
    display: flex;
    max-width: 25.875rem ;
    margin: 0rem auto;
    &.lower-bottom-padding{
        padding-bottom: 0rem;
        .post-thread .thread-line{
            height: calc(100% - 2.9875rem);
        }
    }
    &.post-container-small{
        padding-top: 0.4375rem ;
        padding-bottom:0.4375rem;
        padding-left: 1.5rem;
        .thread-line{
            height: calc(100% - 1.5rem) !important;
        }
    }
    &.post-end-line{
        border-bottom: 0.0625rem solid #15252E;
    }
    .post-thread{
        width: 3.25rem ;
        .post-avatar{
            border-radius: 100%;
            display: block;
            width: 3.25rem;
            &.post-avatar-small{
                width: 1.875rem ;
                margin-left: 0.43rem;
            }
        }
        .thread-line{
            background-color: #15252E;
            height: calc(100% - 2.6875rem);
            width: 0.125rem ;
            border-radius: 0.625rem ;
            margin: 0rem auto;
            margin-top: 0.3125rem ;
        }
    }
    .post-content{
        margin-left: 0.4375rem;
        width: 100%;
        &.post-content-small{
            padding-top: 0.25rem ;
            padding-left: 0.4375rem;
        }

        .post-header{
            .header-text{
                font-family: Roboto;
                font-style: normal;
                font-weight: bold;
                font-size: 1.0625rem ;
                line-height: 1.25rem ;
                letter-spacing: 0rem ;
                .header-username-date   {
                    font-family: Roboto;
                    font-style: normal;
                    font-weight: normal;
                    font-size: 1.0625rem ;
                    color: #8899a6;
                }
            }
        }
        .post-layer{
            margin-bottom: 0.625rem ;

        }
        .post-layer-text{
            font-family: Roboto;
            font-style: normal;
            font-weight: 400;
            font-size: 1.0625rem ;
            line-height: 1.25rem ;
            color: #D1D5DA;
            letter-spacing: 0rem ;
            p{
                margin-bottom: 1rem;
                &.line-without-margin{
                    margin-bottom: 0;
                }
            }
        }
        .post-layer-image{
            .image-card{
                display: inline-block;
                color: white;
                text-decoration: none;
                border-radius: 0.75rem;

                img{
                    border-radius: 0.75rem 0.75rem 0rem 0;
                    border: 0.0625rem solid #15242E;
                    width: 100%;
                    border-bottom: none;
                    &.without-link{
                        border-radius: 0.75rem ;
                        border-bottom: 0.0625rem solid #15242E;
                    }
                }

            }
        }
        .image-card-link{
            background: #000B12;
            border: 0.0625rem solid #15242E;
            box-sizing: border-box;
            border-radius: 0rem 0rem 0.75rem 0.75rem ;
            padding: 0.5rem 0.75rem ;
            .image-link-header{
                font-family: Roboto;
                font-style: normal;
                font-weight: bold;
                font-size: 1.0625rem ;
                line-height: 1.25rem ;
                letter-spacing: 0rem ;
                margin-bottom: 0.08rem ;
            }
            .image-link-caption{
                font-family: Roboto;
                font-style: normal;
                color: #D1D5DA;
                font-weight: 400;
                font-size: 0.875rem ;
                line-height: 1rem ;
                letter-spacing: 0rem ;
            }
        }
        .post-layer-text-card{

            .card-container{
                text-decoration: none;
                display: inline-block;
                width: 100%;
                .post-text-card{
                    width: 100%;
                    height: 11.375rem ;
                    text-align: center;
                    text-decoration: none;
                    border-radius: 0.75rem 0.75rem 0rem 0;
                    border: 0.0625rem solid #15242E;;
                    align-items: center;
                    display: flex;
                    justify-content: center;
                    &.without-link{
                        border-radius: 0.75rem ;
                    }
                }
                .image-card-link{
                    color: white;
                }
            }
        }
        .post-layer-table{
            font-family: Roboto;
            font-style: normal;
            font-weight: normal;
            font-size: 0.875rem ;
            line-height: 1.125rem ;
            letter-spacing: 0rem ;
            .table-row{
                display: flex;
                // background: #000B12;
                border: 0.0625rem solid #15242E;
                border-radius: 0.375rem ;
                padding: 0.375rem 0.625rem ;
                margin-bottom: 0.625rem ;
                text-decoration: none;
                color: #D1D5DA;
                overflow: hidden;
                &.table-row-green{
                    border: 0.0625rem solid #23DCC8;
                }
                &:active{
                    background: rgba(35, 220, 200, 0.113227);
                }
             .table-col{
                width: 100%;
                // display: flex;
                // align-items: center;
                div{

                }
             }
            }
        }
        .post-layer-text-link{
            .post-text-link{
                text-decoration: none;
                font-family: Roboto;
                font-style: normal;
                font-weight: 400;
                font-size: 1.0625rem ;
                line-height: 1.25rem ;
            }
        }

        .post-layer-table-links{
            .table-row{
                text-align: center;
                color: #23DCC8;
                &.table-row-disable{
                    color: #4B5261;
                    background: transparent;
                }
                .table-col{
                    justify-content: center;
                    span{
                        position: relative;
                        .row-tag{
                        color: #F3BA2F;
                        font-family: Roboto;
                        font-style: normal;
                        font-weight: bold;
                        font-size: 6px;
                        position: absolute;
                        margin-left: -1.125rem ;
                        margin-top: -0.65rem ;
                        text-transform: uppercase;
                        text-align: right;
                        right: 0
                        }
                    }
                }
            }
        }
        .post-layer-code-snippet{
            .image-card{
                display: block;
                border: 1px solid red;
                max-width: 19.2rem;
                border-radius: 0.75rem;
                border: 0.0625rem solid #15242E;
                overflow: scroll;
                padding: 1.25rem;
                background-color: #000B12;
                margin-top: 0.9rem;
                img{
                    width: auto;
                    border-radius:0;
                    border:none;

                }
            }

        }
    }
    .anchor-point {
        display: block;
        margin-top: -1.5rem ;
        height: 1.5rem ;
        visibility: hidden;
        pointer-events: none;
    }
}
</style>
